#ifndef __WLAPI_H__
#define __WLAPI_H__

/*---------------------  Export Definitions -------------------------*/
#define EELOAD_IGNORE_ADDR     0x00000001
#define EELOAD_IGNORE_PWR      0x00000002
#define EELOAD_IGNORE_SN       0x00000004
#define EELOAD_IGNORE_ZONE     0x00000008
#define EELOAD_IGNORE_RFTYPE   0x00000010
#define EELOAD_IGNORE_ANTENNA  0x00000020
#define EELOAD_IGNORE_RADIOCTL 0x00000040

/*---------------------  Export Types  ------------------------------*/

/*---------------------  Export Macros ------------------------------*/

/*---------------------  Export Classes  ----------------------------*/

/*---------------------  Export Variables  --------------------------*/

/*---------------------  Export Functions  --------------------------*/
/* Assume C declarations for C++ */
#ifdef __cplusplus
extern "C" {            
#endif  /* __cplusplus */
void* _stdcall OpenDUT(int Mode, int CardType, unsigned long dwLocationID, unsigned long dwLocationIDMask);
void* _stdcall OpenDUTwithDescription(int Mode, char* strDescription, unsigned long dwLocationID, unsigned long dwLocationIDMask);
int _stdcall CloseDUT(void* AdapterObject);
int _stdcall IsDUTExist(void* pDeviceList, int MaxLocationList, int CardType, unsigned long dwLocationID, unsigned long dwLocationIDMask);
int _stdcall ResetTest(void* AdapterObject);

int _stdcall GetDeviceVendorID(void* AdapterObject, unsigned long *DeviceVendorID);
int _stdcall SetNetworkType(void* AdapterObject, int Mode);
int _stdcall GetNetworkType(void* AdapterObject, int *Mode);
int _stdcall SetAntennaBB(void* AdapterObject, int Mode);
int _stdcall GetAntennaBB(void* AdapterObject, int* Mode);
int _stdcall SetDataRate(void* AdapterObject, int Rate);
int _stdcall GetDataRate(void* AdapterObject, int* Rate);
int _stdcall SetChannelDirectCall(void* AdapterObject, int Channel);
int _stdcall GetChannelDirectCall(void* AdapterObject, int* Channel);
int _stdcall SetPreamble(void* AdapterObject, int Mode);
int _stdcall GetPreamble(void* AdapterObject, int* Mode);
int _stdcall SetTxPowerControl(void* AdapterObject, int Value);
int _stdcall GetTxPowerControl(void* AdapterObject, int *Value);
int _stdcall SetTxPowerControlbyPwrMeter(void* AdapterObject, int InitLv1, int MeasuredDbm1, int InitLv2, int MeasuredDbm2, int TragetDbm, int* TargetLv);
int _stdcall SetTxPowerControlbySmartPwrMeter(void* AdapterObject, int InitLv, int MeasuredDbm, int TragetDbm, int* TargetLv);

int _stdcall SetPacketTx(void* AdapterObject, int Mode);
int _stdcall SetPacketLoopback(void* AdapterObject, int Type, int Mode);
int _stdcall SetTxContinuousDirectCall(void* AdapterObject, int Mode);
int _stdcall SetSingleCarrierTxContinuous(void* AdapterObject, int Mode);
int _stdcall SetCarrierSuppressionTx(void* AdapterObject, int Mode);
int _stdcall SetSleepModeDirectCall(void* AdapterObject);
int _stdcall SetWakeModeDirectCall(void* AdapterObject);

int _stdcall WriteCISData(void* AdapterObject, unsigned char* CISData, int Length);
int _stdcall ReadCISData(void* AdapterObject, unsigned char* CISData, int Length, int* pLengthOut);
int _stdcall WritePowerDataArray(void* AdapterObject, char* PowerDataArray);
int _stdcall ReadPowerDataArray(void* AdapterObject, char* PowerDataArray);
int _stdcall ReadPowerControl(void* AdapterObject, int Channel, int RateSelect, int* PowerControl);
int _stdcall WritePowerControl(void* AdapterObject, int Channel, int RateSelect, int PowerControl);
int _stdcall WritePowerControlEx(void* AdapterObject, int Mode, int Channel, int PowerControl, int PowerOutput);
int _stdcall ReadPowerControlEx(void* AdapterObject, int Mode, int Channel, int* PowerControl, int* PowerOutput);
int _stdcall WriteEEprom(void* AdapterObject, unsigned char* EEprom, int Length);
int _stdcall ReadEEprom(void* AdapterObject, char* EEprom, int Length, int* pLengthOut);
int _stdcall SetFilterBB(void* AdapterObject, int Zone);
int _stdcall GetFilterBB(void* AdapterObject, int *Zone);
int _stdcall ReadMACAddress(void* AdapterObject, unsigned char* MACAddress);
int _stdcall WriteMACAddress(void* AdapterObject, unsigned char* MACAddress);
int _stdcall GetRfType(void* AdapterObject, int* Type);
int _stdcall bMACReadEmbeded(void* AdapterObject, unsigned char byIndex, unsigned char* lpbyRegBuffer, unsigned int uLen);
int _stdcall bMACWriteEmbeded(void* AdapterObject, unsigned char byIndex, unsigned char* lpbyRegBuffer, unsigned int uLen);
int _stdcall bSROMReadEmbeded(void* AdapterObject, unsigned char byIndex, unsigned char* lpbyRegBuffer, unsigned int  uLen);
int _stdcall bSROMWriteEmbeded(void* AdapterObject, unsigned char byIndex, unsigned char* lpbyRegBuffer, unsigned int  uLen);
int _stdcall WriteEEpromEX(void* AdapterObject, unsigned char* pbyInBuffer, unsigned char* pbyOutBuffer, unsigned long ulCmd);
int _stdcall IFRFbWriteEmbeded (void* AdapterObject, unsigned long dwVenderId, int bRFReg, unsigned char byLength, unsigned long dwData);
int _stdcall SendPacket(void* AdapterObject, int iRepeat, int iPktPerGrp, int iGrpDelay, unsigned short wPatternType, unsigned int uPayloadLen, unsigned char* pbyDestAddr);
int _stdcall QueryTxPacketSent(void* AdapterObject, int* TxPacketCount);
int _stdcall ResetTxPacketSent(void* AdapterObject);

int _stdcall ReceivePacket(void* AdapterObject, int Mode, int Filter);
int _stdcall QueryRxPacketReceive(void* AdapterObject, int* RxPacketCount, int* RxPacketCrcOKCount);
int _stdcall ResetRxPacketReceive(void* AdapterObject);

int _stdcall QueryTxRxStat(void* AdapterObject, void* StatTable);
int _stdcall ResetTxRxPacketStatistic(void* AdapterObject);

#ifdef __cplusplus
}
#endif  /* __cplusplus */

#endif