/*
 * Copyright (c) 1996, 2003 VIA Networking, Inc. All rights reserved.
 *
 * This software may be redistributed and/or modified under 
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details. 
 *
 * File: device_exp.h
 *
 * Purpose: hardware dependent export functions
 *
 * Author: Lyndon Chen
 *
 * Date: Nov 11, 2003
 *
 */ 

#ifndef __DEVICE_EXP_H
#define __DEVICE_EXP_H

int __device_open(HANDLE pDevice);
int __device_close(HANDLE pDevice);
int __device_xmit(HANDLE pDevice, struct sk_buff *skb);
int __device_intr(int irq, HANDLE pDevice, struct pt_regs *regs);
void __device_set_multi(HANDLE pDevice);
int __device_ioctl(HANDLE pDevice, struct ifreq *rq, int cmd);
struct net_device_stats  *__device_get_stats(HANDLE pDevice);
int __device_hw_reset(HANDLE pDevice);
int __device_hw_init(HANDLE pDevice);
void __device_read_mac(HANDLE pDevice, U8 *dev_addr);
int __device_dma0_tx_80211(HANDLE pDevice, struct sk_buff *skb);

#endif
